
namespace NadeoMaps {
    bool LooksLikeUid(const string &in searchname) {
        if (Regex::IsMatch(searchname, """^[\w]{26,27}$""")) {
            return true;
        }
        return false;
    }
    // standard uuid used for both map id and skin id
    bool LooksLikeId(const string &in searchname) {
        if (Regex::IsMatch(searchname, """^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$""")) {
            return true;
        }
        return false;
    }

    // based on a XertroV plugin
    wstring GetDownloadFromUid(const string &in mapUid, string &out type, string &out mapname) {
        CGameManiaPlanet@ app = cast<CGameManiaPlanet>(GetApp());
        MwId userId = app.MenuManager.MenuCustom_CurrentManiaApp.UserMgr.Users[0].Id;
        CWebServicesTaskResult_NadeoServicesMapScript@ resp = app.MenuManager.MenuCustom_CurrentManiaApp.DataFileMgr.Map_NadeoServices_GetFromUid(userId, mapUid);
        WaitAndClearTaskLater(resp, app.MenuManager.MenuCustom_CurrentManiaApp.DataFileMgr);
        if (resp.HasFailed || !resp.HasSucceeded) {
            print('couldn\'t download from uid: ' + resp.ErrorCode + ", " + resp.ErrorType + ", " + resp.ErrorDescription);
            return "";
        }
        type = resp.Map.Type;
        mapname = resp.Map.Name;
        return resp.Map.FileUrl;
    }

    // maybe get from id? But wouldn't be able to tell if its a map or a skin




}
