
class Skin : ListItem {
    string url;

    Skin(const string &in name, const string &in identifier, const string &in url) {
        super(name, identifier);
        this.url = url;
        if (this.name == "" || this.url == "") {
            startnew(CoroutineFunc(this.GetName));
        }
    }

    void GetName() {
        while (!NadeoServices::IsAuthenticated("NadeoServices")) {yield();}
        Net::HttpRequest@ req = NadeoServices::Get("NadeoServices", NadeoServices::BaseURLCore() + '/skins/' + this.identifier);
        req.Start();
        while (!req.Finished()) {yield();}
        if (req.ResponseCode() != 200) {
            print('invalid http response when getting activity skins skin names' + req.ResponseCode() + ', ' + req.String());
            this.name == "invalid";
            return;
        }
        Json::Value@ response = Json::Parse(req.String());
        if (!response.HasKey('skinDisplayName')) {
            print('invalid response when getting activity skins skin names' + req.String());
            this.name == "invalid";
            return;
        }
        this.name = response['skinDisplayName'];
        this.url = response['fileUrl'];
    }

    // must be called as startnew
    void Equip() {
        if (!Permissions::UseCustomSkin()) {return;}
        while (this.name == "") {yield();} // can wait until getting name (and download url) have finished
        CTrackMania@ app = cast<CTrackMania@>(GetApp());
        CGameDataFileManagerScript@ dataFileMgr = app.MenuManager.MenuCustom_CurrentManiaApp.DataFileMgr;
        CWebServicesTaskResult_NadeoServicesSkinScript@ req = dataFileMgr.AccountSkin_NadeoServices_Set(app.UserManagerScript.Users[0].Id, this.identifier);
        while (req.IsProcessing) {yield();}
        if (req.HasFailed) {
            print('skin equip failed');
            UI::ShowNotification("Play map extended", "Couldn't equip skin");
        }
        dataFileMgr.TaskResult_Release(req.Id);
    }

    // must be called as startnew
    void Save() {
        while (this.name == "") {yield();} // can wait until getting name (and download url) have finished
        string filename = Text::StripOpenplanetFormatCodes(this.name);
        Net::HttpRequest@ req = Net::HttpGet(this.url);
        while (!req.Finished()) {
            yield();
        }
        if (req.String().Length == 0) {
            print('skin download failed');
            UI::ShowNotification("Play map extended", "Couldn't download skin");
            return;
        }
        // CheckDownloadsFolder() // will create a plugin folder in downloads if its not there already
        if (!IO::FolderExists(IO::FromUserGameFolder("Maps/Downloaded/PlayMapExtended"))) {
            IO::CreateFolder(IO::FromUserGameFolder("Maps/Downloaded/PlayMapExtended"), true);
        }
        req.SaveToFile(IO::FromUserGameFolder("Skins/PlayMapExtended/" + filename + '.Map.Gbx'));
        if (Draw::MeasureString("/Skins/PlayMapExtended/" + filename + ".Map.Gbx").x > 350 * UI::GetScale()) {
            UI::ShowNotification("Play map extended", "Saved map to /Skins/PlayMapExtended/\n" + filename + ".Map.Gbx");
        } else {
            UI::ShowNotification("Play map extended", "Saved map to /Skins/PlayMapExtended/" + filename + ".Map.Gbx");
        }
    }

    bool opEquals(Skin@ other) {
        if (this.identifier == other.identifier) {
            return true;
        }
        return false;
    }


    bool Render(const string &in index, int indent, bool allowclose = true) override {
        UI::SetCursorPos(UI::GetCursorPos() + vec2(indentWidth * indent,0));
        UI::Text(this.name); // + "##:" + index + ":" + this.identifier
        UI::SameLine();
        if (UI::Button(Icons::Car + "##:" + index + ":" + this.identifier)) {startnew(CoroutineFunc(this.Equip));}
        UI::SameLine();
        if (UI::Button(Icons::Download + "##:" + index + ":" + this.identifier)) {startnew(CoroutineFunc(this.Save));}        
        return false;
    }
}