
class SkinList : ListItem {
    array<Skin@> skins;
    string url;
    bool hascontents = false;
    bool open;

    SkinList(const string &in name, const string &in identifier, const string &in url, bool collapsed = false) {
        super(name, identifier);
        this.url = url;
        this.hascontents = false;
        this.open = !collapsed;
    }
    
    void GetContents() {
        NadeoActivities::GetSkinsFromNadeoSkinUploads(NadeoServices::BaseURLLive() + "/api/token/club/" + this.url, this);
    }

    void InsertLast(Skin@ skin) {
        this.skins.InsertLast(skin);
    }

    bool Render(const string &in index, int indent, bool allowclose = true) override {
        if (this.open && !this.hascontents) {
            startnew(CoroutineFunc(this.GetContents));
            this.hascontents = true;
        }
        UI::SetCursorPos(UI::GetCursorPos() + vec2(indentWidth * indent,0));
        if (allowclose) {
            if (UI::Button(Icons::Times + '##:'+index)) {return true;}
        } else {
            UI::BeginDisabled();
            UI::Button(Icons::Times + '##:'+index);
            UI::EndDisabled();
        }
        UI::SameLine();
        if (this.open) {
            UI::SetNextItemOpen(this.open);
        }
        if (this.open = UI::CollapsingHeader(this.name + '##:'+index)) {
            if (this.skins.Length > 0) {
                for (uint i = 0; i < this.skins.Length; i++) {
                    if (this.skins[i].Render(index + "." + tostring(i), indent+1)) {
                        this.skins.RemoveAt(i);
                        i--;
                    }
                }
            }
        }
        return false;
    }

    bool Contains(Skin@ skin) {
        for (uint i = 0; i < this.skins.Length; i++) {
            if (this.skins[i] == skin) {
                return true;
            }
        }
        return false;
    }
}
