
namespace TrackmaniaioActivities {
    // bool LooksLikeShortLink(const string &in searchname) {
    //     if (Regex::IsMatch(searchname, """^(https?:[\/\\]{2})?trackmania\.exchange[\/\\]s[\/\\]m[\/\\]\d{1,10}$""")) {
    //         return true;
    //     }
    //     return false;
    // }
    bool LooksLikeCampaign(const string &in searchname) {
        if (Regex::IsMatch(searchname, """^(https?:[\/\\]{2})?trackmania.io[\/\\]#[\/\\]campaigns[\/\\]\d{1,8}[\/\\]\d{1,8}$""")) {
            return true;
        }
        return false;
    }
    bool LooksLikeRoom(const string &in searchname) {
        if (Regex::IsMatch(searchname, """^(https?:[\/\\]{2})?trackmania.io[\/\\]#[\/\\]rooms[\/\\]\d{1,8}[\/\\]\d{1,8}$""")) {
            return true;
        }
        return false;
    }
    bool LooksLikeTrackUpload(const string &in searchname) {
        if (Regex::IsMatch(searchname, """^(https?:[\/\\]{2})?trackmania.io[\/\\]#[\/\\]clubs[\/\\]\d{1,8}[\/\\]maps[\/\\]\d{1,8}$""")) {
            return true;
        }
        return false;
    }
    bool LooksLikeSkinUpload(const string &in searchname) {
        if (Regex::IsMatch(searchname, """^(https?:[\/\\]{2})?trackmania.io[\/\\]#[\/\\]clubs[\/\\]\d{1,8}[\/\\]skins[\/\\]\d{1,8}$""")) {
            return true;
        }
        return false;
    }
    bool LooksLikeClub(const string &in searchname) {
        if (Regex::IsMatch(searchname, """^(https?:[\/\\]{2})?trackmania.io[\/\\]#[\/\\]clubs[\/\\]\d{1,8}[\/\\]?(activities|summary|members)?$""")) {
            return true;
        }
        return false;
    }


    void SetMapsFromCampaign(string &in campaignlink) {
        if (campaignlink.StartsWith('https:')) {
            campaignlink = campaignlink.SubStr(34);
        } else if (campaignlink.StartsWith('http:')) {
            campaignlink = campaignlink.SubStr(23);
        } else {
            campaignlink = campaignlink.SubStr(26);
        }
        for (int i = maplists.Length - 1; i >= 0; i--) {
            if (maplists[i].identifier == "nadeo:"+campaignlink) {
                return;
                // maplists.RemoveAt(i);
            }
        }
        campaignlink = campaignlink.SubStr(0, campaignlink.IndexOf("/") + 1) + 'campaign' + campaignlink.SubStr(campaignlink.IndexOf("/"));
        maplists.InsertFirst(MapList("", campaignlink.SubStr(campaignlink.LastIndexOf("/")+1), MapListType::Campaign, campaignlink, false));
    }

    void SetMapsFromRoom(string &in roomlink) {
        if (roomlink.StartsWith('https:')) {
            roomlink = roomlink.SubStr(30);
        } else if (roomlink.StartsWith('http:')) {
            roomlink = roomlink.SubStr(19);
        } else {
            roomlink = roomlink.SubStr(22);
        }
        for (int i = maplists.Length - 1; i >= 0; i--) {
            if (maplists[i].identifier == "nadeo:"+roomlink) {
                return;
                // maplists.RemoveAt(i);
            }
        }
        roomlink = roomlink.SubStr(0, roomlink.IndexOf("/") + 1) + 'room' + roomlink.SubStr(roomlink.IndexOf("/"));
        maplists.InsertFirst(MapList("", roomlink.SubStr(roomlink.LastIndexOf("/")+1), MapListType::Room, roomlink, false));
    }

    void SetMapsFromTrackUpload(string &in trackuploadlink) {
        if (trackuploadlink.StartsWith('https:')) {
            trackuploadlink = trackuploadlink.SubStr(30);
        } else if (trackuploadlink.StartsWith('http:')) {
            trackuploadlink = trackuploadlink.SubStr(19);
        } else {
            trackuploadlink = trackuploadlink.SubStr(22);
        }
        for (int i = maplists.Length - 1; i >= 0; i--) {
            if (maplists[i].identifier == "nadeo:"+trackuploadlink) {
                return;
                // maplists.RemoveAt(i);
            }
        }
        trackuploadlink = trackuploadlink.SubStr(0, trackuploadlink.IndexOf("/") + 1) + 'bucket' + trackuploadlink.SubStr(trackuploadlink.LastIndexOf("/"));
        maplists.InsertFirst(MapList("", trackuploadlink.SubStr(trackuploadlink.LastIndexOf("/")+1), MapListType::MapUploads, trackuploadlink, false));
    }
    
    void SetSkinsFromSkinUpload(string &in skinuploadlink) {
        if (skinuploadlink.StartsWith('https:')) {
            skinuploadlink = skinuploadlink.SubStr(30);
        } else if (skinuploadlink.StartsWith('http:')) {
            skinuploadlink = skinuploadlink.SubStr(19);
        } else {
            skinuploadlink = skinuploadlink.SubStr(22);
        }
        for (int i = maplists.Length - 1; i >= 0; i--) {
            if (maplists[i].identifier == "nadeo:"+skinuploadlink) {
                return;
                // maplists.RemoveAt(i);
            }
        }
        skinuploadlink = skinuploadlink.SubStr(0, skinuploadlink.IndexOf("/") + 1) + 'bucket' + skinuploadlink.SubStr(skinuploadlink.LastIndexOf("/"));
        maplists.InsertFirst(SkinList("", skinuploadlink.SubStr(skinuploadlink.LastIndexOf("/")+1), skinuploadlink, false));
    }

    void SetActivitiesFromClub(string &in clublink) {
        if (clublink.StartsWith('https:')) {
            clublink = clublink.SubStr(30);
        } else if (clublink.StartsWith('http:')) {
            clublink = clublink.SubStr(19);
        } else {
            clublink = clublink.SubStr(22);
        }

        if (clublink.Contains("/")) {
            clublink = clublink.SubStr(0, clublink.IndexOf("/"));
        } else if (clublink.Contains("\\")) {
            clublink = clublink.SubStr(0, clublink.IndexOf("\\"));
        }

        for (int i = maplists.Length - 1; i >= 0; i--) {
            if (maplists[i].identifier == "nadeo:"+clublink) {
                return;
                // maplists.RemoveAt(i);
            }
        }
        NadeoActivities::GetActivitiesFromClub(clublink);
    }
}