
[Setting name="Color plugins menu name"]
bool colorDisplayName = true;

[Setting name="Show in menu when overlay hidden"]
bool showOverlayHiddenMenu = true;
[Setting name="Show in maps when overlay hidden"]
bool showOverlayHiddenMap = false;

[Setting name="Start enabled"]
bool startOpen = false;

bool showInterface = startOpen;

void RenderMenu() {
    if (colorDisplayName) {
        if (UI::MenuItem("\\$49e" + Icons::ArrowRight + "\\$bbf Play map extended", "", showInterface)) {
            showInterface = !showInterface;
        }
    } else {
        if (UI::MenuItem("\\$29e" + Icons::ArrowRight + "\\$z Play map extended", "", showInterface)) {
            showInterface = !showInterface;
        }
    }
}



string inputText = "";

ListList@ maplists = ListList("mappack and campaign input results", 'maplists', false);
// string currentmaps = "";

void Render() {
    if (!showInterface) {return;}
    if (GetApp() is null) {return;}
    CGameCtnChallenge@ rootmap = GetApp().RootMap;
    if (!UI::IsOverlayShown()) {
        if (rootmap is null) {
            if (!showOverlayHiddenMenu) {return;}
        } else {
            if (!showOverlayHiddenMap) {return;}
        }
    }
    if (!showInterface) {return;}

    UI::SetNextWindowSize(0, 0, UI::Cond::Always);
    if (UI::Begin("Play map extended", showInterface, UI::WindowFlags::NoCollapse)) {
        // current map
        if (rootmap is null) {
            UI::BeginDisabled();
            UI::Text('Current map: None');
            UI::SameLine();
            UI::Button(Icons::Play + '##currentmap', vec2(0,0));
            UI::SameLine();
            UI::Button(Icons::Download + '##currentmap', vec2(0,0));
            UI::SameLine();
            UI::Button(Icons::Pencil + '##currentmap', vec2(0,0));
            UI::SameLine();
            UI::Button(Icons::Star + '##currentmap', vec2(0,0));
            UI::Text(' (uid: )');
            UI::SameLine();
            UI::Button(Icons::FilesO + '##currentmap', vec2(0,0));
            UI::EndDisabled();
        } else {
            UI::Text('Current map: ' + Text::OpenplanetFormatCodes(rootmap.MapName));
            UI::SameLine();
            CGameCtnEditorFree@ editor = cast<CGameCtnEditorFree>(GetApp().Editor);
            if (editor !is null) {
                if (isLoadingMap) {
                    UI::BeginDisabled();
                    UI::Button(Icons::Play + '##currentmap', vec2(0,0));
                    UI::EndDisabled();
                } else {
                    if (UI::Button(Icons::Play + '##currentmap', vec2(0,0))) {
                        maptoload = rootmap.IdName;
                        loadmapas = LoadAs::Solo;
                    }
                }
                UI::SameLine();
                if (UI::Button(Icons::FloppyO + '##currentmap', vec2(0,0))) {editor.ButtonSaveOnClick();}
                UI::SameLine();
                UI::BeginDisabled();
                UI::Button(Icons::Pencil + '##currentmap', vec2(0,0));
                UI::EndDisabled();
                UI::SameLine();
                if (Favourites::isValid && !Favourites::isRefreshing && Favourites::Favourites.Contains(rootmap.IdName)) {
                    if (UI::Button(Icons::StarO + '##currentmap', vec2(0,0))) {startnew(UnfavouriteMap, rootmap.IdName);}
                } else {
                    UI::BeginDisabled();
                    UI::Button(Icons::Star + '##currentmap', vec2(0,0));
                    UI::EndDisabled();
                }
            } else {
                UI::BeginDisabled();
                UI::Button(Icons::Play + '##currentmap', vec2(0,0));
                UI::EndDisabled();
                UI::SameLine();
                if (UI::Button(Icons::Download + '##currentmap', vec2(0,0))) {startnew(SaveMap, rootmap.IdName);}
                UI::SameLine();
                if (isLoadingMap) {
                    UI::BeginDisabled();
                    UI::Button(Icons::Pencil + '##currentmap', vec2(0,0));
                    UI::EndDisabled();
                } else {
                    if (UI::Button(Icons::Pencil + '##currentmap', vec2(0,0))) {
                        maptoload = rootmap.IdName;
                        loadmapas = LoadAs::Editor;
                    }
                }
                UI::SameLine();
                if (!Favourites::isValid || Favourites::isRefreshing) {
                    UI::BeginDisabled();
                    UI::Button(Icons::Star + '##currentmap', vec2(0,0));
                    UI::EndDisabled();
                } else {
                    if (Favourites::Favourites.Contains(rootmap.IdName)) {
                        if (UI::Button(Icons::StarO + '##currentmap', vec2(0,0))) {startnew(UnfavouriteMap, rootmap.IdName);}
                        if (UI::IsItemHovered()) {
                            UI::BeginTooltip();
                            UI::Text('Remove favourite');
                            UI::EndTooltip();
                        }
                    } else {
                        if (UI::Button(Icons::Star + '##currentmap', vec2(0,0))) {startnew(FavouriteMap, rootmap.IdName);}
                        if (UI::IsItemHovered()) {
                            UI::BeginTooltip();
                            UI::Text('Add favourite');
                            UI::EndTooltip();
                        }
                    }
                }
            }
            UI::Text(' (uid: ' + rootmap.IdName + ')');
            UI::SameLine();
            if (UI::Button(Icons::FilesO + '##currentmap', vec2(0,0))) {IO::SetClipboard(rootmap.IdName);}
        }
        UI::Separator();

        // input textbox
        UI::Text('input map uid, tmx, or trackmania.io');
        // int length = int(nvg::TextBounds(inputText).x);
        int length = int(Draw::MeasureString(inputText).x / UI::GetScale() + (UI::GetStyleVarVec2(UI::StyleVar::FramePadding).x * 3));
        if (length < UI::GetScale() * 100) {
            length = int(UI::GetScale() * 100);
        }
        UI::SetNextItemWidth(length);
        bool confirm = false;
        inputText = UI::InputText("##uidinput", inputText, confirm, UI::InputTextFlags::EnterReturnsTrue|UI::InputTextFlags::NoHorizontalScroll);
        LooksType inputtype = LooksLike(inputText);
        if (inputtype == LooksType::None) {
            UI::SameLine();
            if (UI::Button(Icons::Question + '##uidinput', vec2(0,0)) or confirm) {
                UI::ShowNotification("Play map extended", "Unrecognised input type");
            }
        } else if (inputtype == LooksType::Map) {
            UI::SameLine();
            if (isLoadingMap) {
                UI::BeginDisabled();
                UI::Button(Icons::Play + '##uidinput', vec2(0,0));
                UI::EndDisabled();
            } else {
                if (UI::Button(Icons::Play + '##uidinput', vec2(0,0)) or confirm) {
                    maptoload = inputText.Trim();
                    loadmapas = LoadAs::Solo;
                    inputText = "";
                }
            }
            UI::SameLine();
            if (UI::Button(Icons::Download + '##uidinput', vec2(0,0))) {startnew(SaveMap, inputText);}
            UI::SameLine();
            if (isLoadingMap) {
                UI::BeginDisabled();
                UI::Button(Icons::Pencil + '##uidinput', vec2(0,0));
                UI::EndDisabled();
            } else {
                if (UI::Button(Icons::Pencil + '##uidinput', vec2(0,0))) {
                    maptoload = inputText.Trim();
                    loadmapas = LoadAs::Editor;
                    inputText = "";
                }
            }
            UI::SameLine();
            if (!Favourites::isValid || Favourites::isRefreshing) {
                UI::BeginDisabled();
                UI::Button(Icons::Star + '##uidinput', vec2(0,0));
                UI::EndDisabled();
            } else {
                if (Favourites::Favourites.Contains(inputText)) {
                    if (UI::Button(Icons::StarO + '##uidinput', vec2(0,0))) {startnew(UnfavouriteMap, inputText);}
                    if (UI::IsItemHovered()) {
                        UI::BeginTooltip();
                        UI::Text('Remove favourite');
                        UI::EndTooltip();
                    }
                } else {
                    if (UI::Button(Icons::Star + '##uidinput', vec2(0,0))) {startnew(FavouriteMap, inputText);}
                    if (UI::IsItemHovered()) {
                        UI::BeginTooltip();
                        UI::Text('Add favourite');
                        UI::EndTooltip();
                    }
                }
            }
        } else if (inputtype == LooksType::Activity) {
            UI::SameLine();
            if (UI::Button(Icons::List + '##uidinput', vec2(0,0)) or confirm) {
                startnew(DisplayMaps, inputText);
                inputText = "";
            }
        }

        UI::Separator();
        UI::PushStyleColor(UI::Col::Header, vec4(UI::GetStyleColor(UI::Col::Header).x * 0.8, UI::GetStyleColor(UI::Col::Header).y * 0.8, UI::GetStyleColor(UI::Col::Header).z * 0.8, UI::GetStyleColor(UI::Col::Header).w));
        UI::PushStyleColor(UI::Col::HeaderHovered, vec4(UI::GetStyleColor(UI::Col::HeaderHovered).x * 0.8, UI::GetStyleColor(UI::Col::HeaderHovered).y * 0.8, UI::GetStyleColor(UI::Col::HeaderHovered).z * 0.8, UI::GetStyleColor(UI::Col::HeaderHovered).w));
        UI::PushStyleColor(UI::Col::HeaderActive, vec4(UI::GetStyleColor(UI::Col::HeaderActive).x * 0.8, UI::GetStyleColor(UI::Col::HeaderActive).y * 0.8, UI::GetStyleColor(UI::Col::HeaderActive).z * 0.8, UI::GetStyleColor(UI::Col::HeaderActive).w));
        if (Favourites::isValid) {
            if (Favourites::Favourites.Render("-2", 0)) {
                Favourites::isValid = false;
            }
        } else {
            UI::Text("Loading favourites...");
        }
        UI::Separator();
        if (!(viewedServerMaps is null)) {
            if (viewedServerMaps.Render("-1", 0)) {
                @viewedServerMaps = null;
            }
        } else {
            UI::Text("Maps from viewed club rooms will show here");
        }
        UI::Separator();
        // searched map lists
        maplists.Render("0", 0, false);
        UI::PopStyleColor(3);
        // UI::EndChild();
    }
    UI::End();
}

//app.MenuManager.MenuCustom_CurrentManiaApp.UILayers
// .ManialinkPageUtf8.IndexOf("Page_JoinSession") != -1
// .ManialinkPageUtf8.IndexOf("Page_ClubEditionInfoDepreciated") != -1